package sugar;

public class Combinatorics {

/** Get number of variations.
 *
 */
  public static long countVars(int n, int k) {
    if (n<0 || k<0 || k>n) throw new IllegalArgumentException();
    long v=1L;
    for (int j=0; j<k; j++, --n) {
      if (Long.MAX_VALUE/n < v) throw new ArithmeticException();
      v=v*n;
    }
    return v;
  }

/** Get number of variations.
 *
 */
  public static long countCombs(int n, int k) {
    if (n<0 || k<0 || k>n) throw new IllegalArgumentException();
    long c=1L;
    for (int j=0; j<k; j++, --n) {
      if (Long.MAX_VALUE/n < c) throw new ArithmeticException();
      c*=n;
      c/=(j+1);
    }
    return c;
  }

/** Get number of variations.
 *
 */
  public static byte[] getVars(byte n, byte k) {
    long size=countVars(n,k);
    if (size > Integer.MAX_VALUE) throw new IllegalArgumentException("over");

    byte [] v= new byte[(int)(size*k)];
    System.out.println("arr  "+(int)(size*k));

    for (int i = 0; i < k; i++) { v[i]=(byte)(i+1); }

    for (int j = k; j <v.length; j+=k) {
       for (int i = 0; i < k; i++)   v[j+i]=v[j+i-k];

         do {
           for (int m = k-1; m >=0 ; m--) {
              byte s=++v[j+m];
              if (s<=n) { break; }
              v[j+m]=1;
           }
         } while (!isUnique(v, j, k));
    }
    return v;
  }


  public static byte[] getCombs(byte n, byte k) {
    long size=countCombs(n,k);
    if (size > Integer.MAX_VALUE) throw new IllegalArgumentException("over");

    byte [] v= new byte[(int)(size*k)];
    System.out.println("arr  "+(int)(size*k));

    for (int i = 0; i < k; i++) { v[i]=(byte)(i+1); }

    for (int j = k; j <v.length; j+=k) {
       for (int i = 0; i < k; i++)   v[j+i]=v[j+i-k];

         do {
           for (int m = k-1; m >=0 ; m--) {
              byte s=++v[j+m];
              if (s<=n) { break; }
              v[j+m]=1;
           }
         } while (!isAscending(v, j, k));
    }
    return v;
  }

/** Get number of variations.
 *
 */
  public static boolean isUnique(byte[] a, int off, int len) {
     for (int i=off; i<off+len; i++)
        for (int j=i+1; j<off+len; j++)
           if (a[i]==a[j]) return false;
     return true;
  }
/** Get number of variations.
 *
 */
  public static boolean isAscending(byte[] a, int off, int len) {
     for (int i=off; i<off+len; i++)
        for (int j=i+1; j<off+len; j++)
           if (a[i]>=a[j]) return false;
     return true;
  }

  public static void main(String[] args) {
     byte n=16, k=8;
     System.out.println("    ="+Math.pow(n,k));

       long c=countCombs(n,k);
       System.out.println("c="+c);


/*

     long v=countVars(n,k);
     System.out.println("v="+v);
*/
     byte[] r={1,2,3,4,5,7};
     System.out.println(isUnique(r,0,r.length));

     byte[] q=getCombs(n,k);

     for (int j = 0; j <q.length; j+=k) {
        System.out.print("\n"+j/k+"  ");
        for (int i = 0; i < k; i++) {
           System.out.print("  "+q[j+i]);
        }
     }

     System.out.println("\n  stop");
  }
}