package sugar;
import java.text.*;
import java.util.*;

public class Num {
  private static Locale locus=Locale.US, loccz=new Locale("cs","CZ"),
                        loc=locus ;
  private static DecimalFormat df;
  private static final String zeroes="0000000000000000";

  static { df=set(loc,2); }

  public  static String form(double x) { return df.format(x); }

  public  static String form(double x, int mf) {
     String s=set(loc,mf).format(x);
     int i=s.indexOf('.'); int j=s.indexOf(',');
     i=Math.max(i,j);
     int n=0;
     if (i<0) s+="."; else n=s.length()-i-1;
     s+=zeroes.substring(0,Math.min(mf-n,16));
     return s;
  }

  public  static void setFract(int mf) { df=set(loc,mf); }

  private static DecimalFormat set(Locale loc, int mf) {
     DecimalFormat dfx=(DecimalFormat)NumberFormat.getInstance(loc);
     dfx.setMaximumFractionDigits(mf);
     dfx.setGroupingSize(50);
     return dfx;
  }

  public static void main(String[] args) {
     double x=Math.PI;
     System.out.println(x+" "+Num.form(x)+"  "+Num.form(x,3));
     Num.setFract(4);
     System.out.println(x+" "+Num.form(x));
  }
}